import 'package:particle_ui/particle.dart';

enum DividerType {
  thinnest, thinner, thin, thick, thicker, thickest
}

class Divider extends StatelessWidget {
  final DividerType type;
  final double thickness;
  final Fill fill;
  final EdgeInsets margin;

  const Divider({Key key, this.type = DividerType.thinnest, this.thickness, this.fill, this.margin}) : assert(type != null), super(key: key);

  const Divider.thinnest({Key key, this.margin}) : type = DividerType.thinnest, thickness = null, fill = null, super(key: key);
  const Divider.thinner({Key key, this.margin}) : type = DividerType.thinner, thickness = null, fill = null, super(key: key);
  const Divider.thin({Key key, this.margin}) : type = DividerType.thin, thickness = null, fill = null, super(key: key);
  const Divider.thick({Key key, this.margin}) : type = DividerType.thick, thickness = null, fill = null, super(key: key);
  const Divider.thicker({Key key, this.margin}) : type = DividerType.thicker, thickness = null, fill = null, super(key: key);
  const Divider.thickest({Key key, this.margin}) : type = DividerType.thickest, thickness = null, fill = null, super(key: key);

  @override
  Widget build(BuildContext context) {
    Divider _theme = Theme.of(context).dividers[type];
    assert(_theme != null);

    Divider _property = mergeWith(_theme);

    return Surface(
      size: Size(height: _property.thickness),
      fill: _property.fill,
      margin: _property.margin
    );
  }

  Divider mergeWith(Divider divider) {
    if (divider != null) {
      return Divider(
        thickness: thickness ?? divider.thickness,
        fill: fill ?? divider.fill,
        margin: margin ?? divider.margin
      );
    } else {
      return this;
    }
  }
}